/*;  khdfstream.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl khdfstream.h\quad\thepage}} */
/*;  $$Date: 1997/09/26 04:41:33 $$  */
/*;  $$Source: /home/shiiba/KhProgDevelop/KhC++Lib/dfstream/khdfstream.h,v $$  */

// @(#) KhDfstream 饹 (ʸκ)

#include <fstream>
#include <unistd.h>

using namespace std;

class KhDfstream : public ifstream
{

/*
    ʸޤǡեɤ߼뤿Υ饹

    Class for reading data files with "comment strings."

    What are "comment strings"?

    The strings from character # to the end of the line are
    regarded as "comment strings" and are ignored when being read.
    If character # appears at the first column, then the line
    itself is ignored.  The charcters # within the strings
    surrownded by "..." or '...' are not regarded the starts of
    comment strings.

    If you read a data file using KhDfstream class, you can ignore
    comment strings in the file.

	For example, assume file "foo.data" is as follows

	1 2 # the strings after # are comments
	# this line will be ignored
	3

    

	Then the codes

	int ia, ib, ic;
	KhDfstream fi("foo.data");
    fi >> ia >> ib >> ic;

	will set ia, ib, and ic to be 1, 2, and 3, respectively.

*/

 public:
  KhDfstream()            // constructor
	: ifstream()
  {
    openFlag = 0;

    // added by iYutaka (Thu Dec 18 11:51:04 2003)
    strcpy(dfname, "/tmp/khdfstream.XXXXXX");
  }

  KhDfstream(             // constructor. Construct and open a file.
	const char* name)	// file name to be opened
	: ifstream()
  {
    openFlag = 0;

    // added by iYutaka (Thu Dec 18 11:51:04 2003)
    strcpy(dfname, "/tmp/khdfstream.XXXXXX");

    open(name);
  }

  void open(            // open a data file
	const char* name);  // file name to be opened

  void close();         // close the file

  ~KhDfstream();

 protected:
  char dfname[128];     // name of a working file
  int openFlag;         // initially zero, when a working file is
                        // created, 1.
};

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */


/*; end of file */
